package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"reflect"
	"xorm.io/xorm"
)

type CentralKitchenForSchoolWithSpec struct {
	Db           *xorm.Engine `json:"db"`
	EnterpriseId int          `json:"enterprise_id"`
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) Set(enterpriseId int) { // set方法
	centralKitchenForSchoolWithSpecDb.Db = Db
	centralKitchenForSchoolWithSpecDb.EnterpriseId = enterpriseId
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) GetCentralKitchenForSchoolWithSpecById(id int) (m *model.CentralKitchenForSchoolWithSpec, err error) {
	m = new(model.CentralKitchenForSchoolWithSpec)
	has, err := centralKitchenForSchoolWithSpecDb.Db.Where("id =?", id).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) GetCentralKitchenForSchoolWithSpec() (m *model.CentralKitchenForSchoolWithSpec, err error) {
	m = new(model.CentralKitchenForSchoolWithSpec)
	has, err := centralKitchenForSchoolWithSpecDb.Db.Where("enterprise_id =?", centralKitchenForSchoolWithSpecDb.EnterpriseId).Get(m)
	if err != nil {
		return nil, logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return m, nil
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) CentralKitchenForSchoolWithSpecInsert(m *model.CentralKitchenForSchoolWithSpec) (int, error) {
	_, err := centralKitchenForSchoolWithSpecDb.Db.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return m.Id, nil
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) BatchAddCentralKitchenForSchoolWithSpecs(mm []*model.CentralKitchenForSchoolWithSpec) (int64, error) {
	affected, err := centralKitchenForSchoolWithSpecDb.Db.Insert(mm)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) CentralKitchenForSchoolWithSpecDeleteById(id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.CentralKitchenForSchoolWithSpec{})
	} else {
		return Db.Where("id = ?", id).Delete(model.CentralKitchenForSchoolWithSpec{})
	}
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) CentralKitchenForSchoolWithSpecDelete() (int64, error) {
	return Db.Where("enterprise_id = ?", centralKitchenForSchoolWithSpecDb.EnterpriseId).Delete(model.CentralKitchenForSchoolWithSpec{})
}

func (centralKitchenForSchoolWithSpecDb *CentralKitchenForSchoolWithSpec) CentralKitchenForSchoolWithSpecUpdate(id interface{}, m *model.CentralKitchenForSchoolWithSpec, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = centralKitchenForSchoolWithSpecDb.Db.Where("id=?", id).Cols(forceColums...).Update(m)
	} else {
		affected, err = centralKitchenForSchoolWithSpecDb.Db.Where("id=?", id).Update(m)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}
